require 'open-uri'
require 'rubygems'
require 'sinatra'
require 'json'

helpers do
  alias_method :h, :escape_html

  def recent_gems
    url = "http://twitter.com/statuses/user_timeline/14881835.json"
    json = open(url).read

    JSON.parse(json).map{|post|
      post["text"] =~ %r{(.*?): (.*)(http://.*)}m
      [$1, $2, $3, post["created_at"]]
    }
  end
end

get "/" do
  erb %{
    <!DOCTYPE html>
    <html>
    <head>
      <meta charset="UTF-8" />
      <link rel="stylesheet" href="/screen.css" type="text/css" />
    </head>
    <body>
      <h1>New Gems</h1>
      <ul>
      <% recent_gems.each do |name, text, url, time| %>
        <li>
          <a href='<%= h url %>'><%= h name %></a><br>
          <%= h text %> ( <%= h time %> )
        </li>
      <% end %>
      </ul>
      <script type='text/javascript'>
        setTimeout(function(){
          document.location.reload();
        }, 1000 * 60 * 10);
      </script>
    </body>
    </html>
  }
end

